{
  myAutoPilot Project
  Sungyong Kim
  sungyong615@hotmail.com
  04/15/2009
  
  Part 2:   myAutopilot GPS Data Output

  I modified Earl's AutoPilotPro code.
  Earl mentioned on his code that
  Contibutions by:
    Chris Anderson
    Jordi
    Paul Huber
    John Abshier,MagIO2 and SSteve from the Parallax forum
    thank you many other helpers on one way or another.....

----- Prop Pin Outs -----
Free Pins     0,3 to 7                         

Used Pins for interfacing various things to Prop
1  GPS Rx   @ 57500 baud
2  GPS Tx
12 TV out   1.1 kohm
13 TV sub   560  ohm
14 TV sub   270  ohm                                                
15 TV sub   560  ohm                                                
}
CON

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

' LS20031 GPS Assignments                                        
  GPSin     = 2                          ' Tx GPS NEMA data @ 57600 baud
  GPSout    = 1                          ' Rx GPS
                                         ' to GPS (to set baud, SIRF or NMEA etc. May be needed for your GPS)
' Video Output Assignments                              
  TVBase    = 12                         ' TV base pin         

VAR
  byte buffer [16]
  long  stackGPS[512]
  long  stackDOF[200]
  long _220uS,osd
  byte i2cSCL, i2cSDA
  long degree
  long latitude,longitude,altitude

   
OBJ                                                    
  clock      :  "Clock"                                 ' overall timers 
  tv         :  "tv_text"                               ' TV video output driver
  gps        :  "GPS_IO_mini_PNAV"                      ' Services GPS input and etrex extension           
  ser        :  "FullDuplexSerial_mini"
  uart       :  "FullDuplexSerialPlus"
  uartDOF    :  "FullDuplexSerialPlusDOF"

PUB start

Clock.Init(_XINFREQ)                  ' set up clock for accurate 10/second
Clock.SetClock(_CLKMODE)              ' video update rate
Clock.MarkSync

tv.start(TVBase)                      ' start TV display
tv.str(string($A,7,$B,1,$C,33))       ' set TV to line 1 col 33 white on red                            

degree := 0                           ' initial heading
osd := 1                              ' draw screen
OSD_INI_Screen                        ' Print AutoPilot data Layout Screen
OSD_INI_Screen                        ' Havent figgured out why I need to do this twice ???                
gps.start(GPSin,GPSout)               ' start GPS ingest (gets its own cog)
ControlLoop                           ' overall control loop

'***************************************************************************************
'                               Main program
'***************************************************************************************
                        
PUB ControlLoop                       ' primary loop
repeat

     OSD_GPS1                         ' Print all data on TV      
 '   waitcnt(2500 + cnt)              ' wait a short time
     tv.str(string(4))                
     waitcnt(2500000 + cnt)           
     tv.str(string($A,38,$B,8))                     
   tv.str(string(5))

'*************************** Display GPS data on TV  *****************************************       
' GPS data !
'Do everything over and over !
'*********************************************************************************************

Pub OSD_INI_Screen                      'Set Inishall OSD Screen


    tv.out($0)
  
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789

    tv.str(string("___________ myAutoPilot Data __________",13))    'setup the tv screen graphics layout
    tv.str(string("Lock:  x                               ",13))
    tv.str(string("Latitude:     _xxxx.xx    #Sat         ",13))
    tv.str(string("Longitude:    xxxxx.xx    GpsA         ",13))
    tv.str(string("Spd:                      Head: xxx    ",13))
    tv.str(string("AutoPilot-                             ",13))

'                  0         1         2         3        
'                  0123456789012345678901234567890123456789


Pub OSD_GPS1                  'On Screen Display Updater

'                             *** Print GPS Valid (A - X - V) ***
                                     
   tv.str(string($A,7,$B,1))    ' set to line 1 col 7                                  
   tv.str(gps.valid)

'                             ***  Print Latitude ***

  tv.str(string($A,15,$B,2))        ' set to line 2 col 15
  tv.dec(latitude)

'                             ***  Print N or S ***

  tv.str(string($A,24,$B,2))        ' set to line 2 col 26                        
  tv.str(gps.N_S)

'                             ***  Print Number of saellites in view ***

  tv.str(string($A,34,$B,2))        ' set to line 2 col 34                        
  tv.str(gps.satellites)

  tv.str(string($A,14,$B,3))                                
     tv.dec(longitude)

                                   
   tv.str(string($A,24,$B,3))                                
    tv.str(gps.E_W)
      tv.str(string($A,33,$B,3))
   tv.dec(altitude)                     'change to feet ******************************
   tv.str(string($A,7,$B,4))                                
    tv.str(gps.speed)
   tv.str(string($A,20,$B,4))                                
 tv.str(string("     "))
  tv.str(string($A,20,$B,4))                                

       tv.str(string($A,32,$B,4))                                
    tv.str(gps.heading)

    gps.altitude
  altitude :=  (((uart.StrToDec(gps.altitude)/10) * 328)/100)   'Convert GPS meters string to desimal feet number